(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_xml_arrow_number ppf = function
  | u_a -> Udynamic_graph_print_xml.print_xml_arrow_number ppf u_a
;;

let print_xml_delayed_image px_a ppf = function
  | Udelayed_dgraph.Not_yet_computed ->
    Format.fprintf ppf "%s" "<Not_yet_computed/>"
  | Udelayed_dgraph.Image a ->
    Format.fprintf ppf "@[<1>%s@," "<Image>"; px_a ppf a;
    Format.fprintf ppf "%,</Image>"; Format.fprintf ppf "%,@]"
;;

let print_xml_delayed_arrow px_a px_b ppf = function
  | a_b_d_u_a ->
    Udynamic_graph_print_xml.print_xml_arrow px_a
     (print_xml_delayed_image px_b) ppf a_b_d_u_a
;;

let print_xml_t px_a px_b px_c ppf = function
  | {
      Udelayed_dgraph.f = f_c_f_a_f_a_b;
      Udelayed_dgraph.graph = a_b_d_u_t;
      Udelayed_dgraph.to_do = a_l;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Lib_print_xml.print_xml_fun px_c
     (Lib_print_xml.print_xml_fun print_xml_arrow_number
       (Lib_print_xml.print_xml_fun px_a px_b)
     ) ppf f_c_f_a_f_a_b;
    Format.fprintf ppf "%,;";
    Udynamic_graph_print_xml.print_xml_t px_a (print_xml_delayed_image px_b)
     ppf a_b_d_u_t;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_List print_xml_arrow_number ppf a_l;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
