(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_uindex pp_a ppf = function
  | a_u_u -> Unonempty_set_print.print_uindex pp_a ppf a_u_u

and print_index pp_a ppf = function
  | a_u_i -> Unonempty_set_print.print_index pp_a ppf a_u_i
;;

let print_t pp_a ppf = function
  | Uset.Empty -> Format.fprintf ppf "%s" "Empty"
  | Uset.Nonempty a_u_t ->
    Format.fprintf ppf "@[<1>%s@ " "Nonempty";
    Unonempty_set_print.print_t pp_a ppf a_u_t; Format.fprintf ppf "%,@]"
;;

let print_subset pp_a ppf = function
  | { Uset.support = a_t; Uset.indices = a_i_a; Uset.set = a_t0; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>support =@ ";
    print_t pp_a ppf a_t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>indices =@ ";
    Lib_print.print_Array (print_index pp_a) ppf a_i_a;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>set =@ ";
    print_t pp_a ppf a_t0; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@,}@]"
;;

let print_dichotomy pp_a ppf = function
  | (a_s, a_s0) ->
    Format.fprintf ppf "%,@[<1>(@,"; print_subset pp_a ppf a_s;
    Format.fprintf ppf "%,,@ "; print_subset pp_a ppf a_s0;
    Format.fprintf ppf "%,@,)@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
