(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: upositive_rational.mli,v 1.3 2014/01/10 15:28:04 fclement Exp $ *)

(** {3 Positive rational numbers} *)

type t = Upositive_rational_types.t;;

val of_nat : Unatural.t -> Unatural.t -> t;;

val _1_ : t;;

val scale : t -> Unatural.t -> Unatural.t;;

(** {6 Comparison} *)

val compare : t -> t -> int;;

val equal : t -> t -> bool;;
val different : t -> t -> bool;;
val smaller : t -> t -> bool;;
val greater : t -> t -> bool;;
val smaller_or_equal : t -> t -> bool;;
val greater_or_equal : t -> t -> bool;;

val min : t -> t -> t;;
val max : t -> t -> t;;
