(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: upositive_rational_range_types.ml,v 1.4 2014/02/09 17:27:28 fclement Exp $ *)

(* The private type of positive rational number ranges. *)

let prrt_qual = Upervasives.qualify "Upositive_rational_range";;

let prrt_failwith = Upervasives.failwith_qual prrt_qual;;

open Upositive_rational;;

type nonempty_range =
  {
   left : Upositive_rational.t;
   right : Upositive_rational.t;
  }
;;

let to_nonempty_range r1 r2 =
  if greater_or_equal r1 r2 then
    prrt_failwith "to_nonempty_range" "empty range" else
  { left = r1; right = r2; }
;;

type t =
  | Empty
  | Nonempty of nonempty_range
;;
