(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: usubarray_types.mli,v 1.7 2014/01/10 15:28:04 fclement Exp $ *)

(** {3 The private type of subarrays} *)

type index = Upervasives.index;;

type offset = Unatural.t
and length = Upervasives.length
;;

type range =
  {
   offset : offset;
   length : length;
  }
;;

type indices =
  | Range of range
  | Indices of index array
;;

type 'a t = private
  {
   support : 'a array;
   indices : indices;
  }
;;

val range : 'a array -> range -> 'a t;;
val indices : 'a array -> index array -> 'a t;;

val of_t : 'a t -> 'a array * indices;;
