let sub_array_fold_left f accu
    { support = a; offset = ofs; length = len; } =
  if Unatural.add ofs len > Uarray.length a
  then Upervasives.invalid_arg "Sub_array" "fold_left" ""
  else
    let r = ref accu in
    for i = Unatural.to_int ofs to pred (Unatural.to_int len) do
      r := f !r (Array.unsafe_get a i)
    done;
    !r
;;

let sub_array_fold_left_i f accu
    { support = a; offset = ofs; length = len; } =
  if Unatural.add ofs len > Uarray.length a
  then Upervasives.invalid_arg "Sub_array" "fold_left_i" ""
  else
    let r = ref accu in
    for i = Unatural.to_int ofs to pred (Unatural.to_int len) do
      let index = Uindex.of_int i in
      r := f !r index (Array.unsafe_get a i)
    done;
    !r
;;

let sub_array_find p { support = a; offset = ofs; length = len; } =
  if Unatural.add ofs len > Uarray.length a
  then Upervasives.invalid_arg "Sub_array" "find" ""
  else
    let rec loop i =
      if i >= len then raise Not_found else
      let ai = a.(Unatural.to_int i) in
      if p ai then ai else loop (Unatural.succ i) in
    loop ofs
;;

let sub_array_find_all p { support = a; offset = ofs; length = len; } =
  if Unatural.add ofs len > Uarray.length a
  then Upervasives.invalid_arg "Sub_array" "find_all" ""
  else
    let rec loop accu i =
      if i >= len then accu else
      let ai = a.(Unatural.to_int i) in
      if p ai then loop (ai :: accu) (Unatural.succ i) else
      loop accu (Unatural.succ i) in
    loop [] ofs
;;
